com.smartgwt.client.ai

## Class DataQuestionSettings

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.ai.DataQuestionSettings

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers

      public class DataQuestionSettings
      extends DataClass

  Settings for a data question.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DataQuestionSettings()`
    `DataQuestionSettings(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getApplicationPurpose()` A human-readable (and thus AI-readable) description of the purpose of the application.
    `java.lang.String[]` | `getDataSourceNames()` The IDs of available data sources.
    `java.lang.Integer` | `getMaxFixAttempts()` The maximum number of attempts to have AI generate valid code and/or data.
    `static DataQuestionSettings` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.util.Date` | `getReferenceTime()` The reference date & time considered to be the present.
    `DataQuestionSettings` | `setApplicationPurpose(java.lang.String applicationPurpose)` A human-readable (and thus AI-readable) description of the purpose of the application.
    `DataQuestionSettings` | `setDataSourceNames(java.lang.String... dataSourceNames)` The IDs of available data sources.
    `DataQuestionSettings` | `setMaxFixAttempts(java.lang.Integer maxFixAttempts)` The maximum number of attempts to have AI generate valid code and/or data.
    `DataQuestionSettings` | `setReferenceTime(java.util.Date referenceTime)` The reference date & time considered to be the present.

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DataQuestionSettings

          public DataQuestionSettings()

    - #### DataQuestionSettings

          public DataQuestionSettings(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DataQuestionSettings getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setApplicationPurpose

          public DataQuestionSettings setApplicationPurpose(java.lang.String applicationPurpose)

      A human-readable (and thus AI-readable) description of the purpose of the application.
      Parameters:
        `applicationPurpose` - New applicationPurpose value. Default value is null
      Returns:
        `DataQuestionSettings` instance, for chaining setter calls

    - #### getApplicationPurpose

          public java.lang.String getApplicationPurpose()

      A human-readable (and thus AI-readable) description of the purpose of the application.
      Returns:
        Current applicationPurpose value. Default value is null

    - #### setDataSourceNames

          public DataQuestionSettings setDataSourceNames(java.lang.String... dataSourceNames)

      The IDs of available data sources.
      Parameters:
        `dataSourceNames` - New dataSourceNames value. Default value is null
      Returns:
        `DataQuestionSettings` instance, for chaining setter calls
      See Also:
        `GlobalId`

    - #### getDataSourceNames

          public java.lang.String[] getDataSourceNames()

      The IDs of available data sources.
      Returns:
        Current dataSourceNames value. Default value is null
      See Also:
        `GlobalId`

    - #### setMaxFixAttempts

          public DataQuestionSettings setMaxFixAttempts(java.lang.Integer maxFixAttempts)

      The maximum number of attempts to have AI generate valid code and/or data.
      Parameters:
        `maxFixAttempts` - New maxFixAttempts value. Default value is null
      Returns:
        `DataQuestionSettings` instance, for chaining setter calls

    - #### getMaxFixAttempts

          public java.lang.Integer getMaxFixAttempts()

      The maximum number of attempts to have AI generate valid code and/or data.
      Returns:
        Current maxFixAttempts value. Default value is null

    - #### setReferenceTime

          public DataQuestionSettings setReferenceTime(java.util.Date referenceTime)

      The reference date & time considered to be the present.

      If not provided, then the current date & time is used.

      Parameters:
        `referenceTime` - New referenceTime value. Default value is null
      Returns:
        `DataQuestionSettings` instance, for chaining setter calls

    - #### getReferenceTime

          public java.util.Date getReferenceTime()

      The reference date & time considered to be the present.

      If not provided, then the current date & time is used.

      Returns:
        Current referenceTime value. Default value is null